## openmeeg 2.0.0.dfsg

=== CMakeLists.txt ===
################################################################
#
#    Compilation file for OpenMEEG library
#
################################################################

# CMakeLists files in this project can refer to the root source
# directory of the project as ${OpenMEEG_SOURCE_DIR} and
# to the root binary directory of the project as ${OpenMEEG_BINARY_DIR}.

#------------------------------------------------------------
# Project Name
#------------------------------------------------------------

SET(PACKAGE_VERSION_MAJOR "2")
SET(PACKAGE_VERSION_MINOR "0")
SET(PACKAGE_VERSION_PATCH "0")

#   The second path is temporary untill these are integrated in cmake...

# SET(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/macros;${CMAKE_SOURCE_DIR}/macros/FortranCInterface;")
SET(CMAKE_MODULE_PATH
"${CMAKE_SOURCE_DIR}/macros;${CMAKE_SOURCE_DIR}/macros/FortranCInterface;${CMAKE_SOURCE_DIR}/contrib/matio/cmake/")

IF (WIN32)
    SET(CMAKE_REQUIRED_INCLUDES ${CMAKE_CURRENT_SOURCE_DIR}/contrib/matio/contrib/Windows)
ENDIF()

#   The next two lines are a kludge to make rpm generation work. If you change this,
#   please check that rpm generation still works.

SET(CPACK_PACKAGE_VERSION_MAJOR ${PACKAGE_VERSION_MAJOR})
SET(CPACK_PACKAGE_VERSION_MINOR ${PACKAGE_VERSION_MINOR})
SET(CPACK_PACKAGE_VERSION_PATCH ${PACKAGE_VERSION_PATCH})

PROJECT(OpenMEEG C CXX)

CMAKE_MINIMUM_REQUIRED(VERSION 2.6 FATAL_ERROR)

INCLUDE(NewExecutable)
INCLUDE(FindLibrary)
INCLUDE(UnitTest)
INCLUDE(Revision)
INCLUDE(Win32Compat)

GENERATE_VERSION_INFO()

INCLUDE(CompileOptions)

# ==============
# = Endianess =
# ==============

INCLUDE(TestBigEndian)
TEST_BIG_ENDIAN(WORDS_BIGENDIAN)

#######################################################################
# External Libraries
#######################################################################

INCLUDE(VtkOption)
INCLUDE(UseMatio)
INCLUDE(UseAtlas)
INCLUDE(UseOpenMP)

#   Detect Fortran to C interface.

IF(USE_ATLAS)
    INCLUDE(FortranCInterface)
    #FortranCInterface_HEADER(FC.h MACRO_NAMESPACE "FC_" FROM_LIBRARY blas[daxpy] HINTS /usr/lib64 /usr/lib64/atlas /usr/lib64/sse2 /usr/lib /usr/lib/atals /usr/lib/sse2)
    FortranCInterface_HEADER(FC.h MACRO_NAMESPACE "FC_" FROM_LIBRARY blas[daxpy])
ENDIF()

#######################################################################
# Configure files with settings for use by the build.
#######################################################################

CONFIGURE_FILE(${OpenMEEG_SOURCE_DIR}/OpenMEEGConfigure.h.in
               ${OpenMEEG_BINARY_DIR}/OpenMEEGConfigure.h)

#---------------------------------------------------------------
# Include OpenMEEG Directories
#---------------------------------------------------------------

# Include the file with all source tree directories for OpenMEEG

SET (OPENMEEG_INCLUDE_DIRECTORIES
    ${OpenMEEG_BINARY_DIR}
    ${OpenMEEG_SOURCE_DIR}
    ${OpenMEEG_SOURCE_DIR}/src
    ${OpenMEEG_SOURCE_DIR}/libs/MatLib/MatLib
)

INCLUDE_DIRECTORIES(${OPENMEEG_INCLUDE_DIRECTORIES})

#---------------------------------------------------------------
# Setting sources and libraries
#---------------------------------------------------------------

SUBDIRS(contrib libs src)

IF(UNIX)
    INCLUDE(AddDemoTarget)
    ADD_DEMO_TARGET(Head1 forinv)
    ADD_DEMO_TARGET(Head2 forward)
    ADD_DEMO_TARGET(Head3 forward)
    ADD_DEMO_TARGET(nerve1 gain)
ENDIF()

#-----------------------------------------------
# tools
#-----------------------------------------------

OPTION(BUILD_TOOLS "Build tools" ON)

IF (BUILD_TOOLS)
    SUBDIRS(tools)
ENDIF (BUILD_TOOLS)

#-----------------------------------------------
# tests
#-----------------------------------------------

INCLUDE(TestOption)

#-----------------------------------------------
# Dart
#-----------------------------------------------

INCLUDE(Dart)

#-----------------------------------------------
# documentation
#-----------------------------------------------

OPTION(BUILD_DOCUMENTATION "Build Doxygen documentation" OFF)
OPTION(BUILD_TUTORIALS "Build Tutorials" OFF)

SUBDIRS(${OpenMEEG_SOURCE_DIR}/documentation)

#-----------------------------------------------
# Wrapping
#-----------------------------------------------

OPTION(PYTHON_WRAP "Enable Python Wrapping" OFF)

IF (PYTHON_WRAP AND NOT BUILD_SHARED)
    MESSAGE(SEND_ERROR "Python wrapping does not work with static build, consider changing the BUILD_SHARED option.")
ENDIF ()

IF (PYTHON_WRAP AND APPLE AND USE_ICC) # Builtin Python2.5 on Mac OS X in 32 bits...
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m32")
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -m32")
ENDIF ()

SUBDIRS(Wrapping)

#-----------------------------------------------
# Support for make uninstall
#-----------------------------------------------

CONFIGURE_FILE(
    "${CMAKE_CURRENT_SOURCE_DIR}/macros/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

ADD_CUSTOM_TARGET(uninstall
    "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

#-----------------------------------------------
# Code Syntax Checking with KWStyle
#-----------------------------------------------

OPTION(CHECK_SYNTAX "Checking code syntax using KWStyle" OFF)
MARK_AS_ADVANCED(CHECK_SYNTAX)

IF (CHECK_SYNTAX)
    ADD_CUSTOM_TARGET(check_syntax
        COMMAND KWStyle -xml ${OpenMEEG_SOURCE_DIR}/OpenMEEGConfig.kws.xml -html ${OpenMEEG_BINARY_DIR}/KWStyleCheck -D KWStyleFilesToCheck.txt -v
        WORKING_DIRECTORY ${OpenMEEG_SOURCE_DIR})
ENDIF ( CHECK_SYNTAX )

#-----------------------------------------------
# Progress bar
#-----------------------------------------------

OPTION(USE_PROGRESSBAR "Show ascii progress bar when assembling matrices" OFF)

IF ( USE_PROGRESSBAR )
    ADD_DEFINITIONS(-DUSE_PROGRESSBAR)
ENDIF ( USE_PROGRESSBAR )

#-----------------------------------------------
# packaging
#-----------------------------------------------

INCLUDE(Packaging)

#######################################################################
# Help other projects use OpenMEEG
# DEFINED FOR OpenMEEGConfig.cmake.in file
#######################################################################

#-----------------------------------------------
# Creating files for external projects
#-----------------------------------------------

# Include the libraries and their directories for OpenMEEG

SET (OPENMEEG_LIBRARY_DIRECTORIES
    ${OpenMEEG_BINARY_DIR}/src
    ${OpenMEEG_BINARY_DIR}/libs/MatLib/MatLib
)

SET(OPENMEEG_SOURCE_DIRECTORIES ${OpenMEEG_SOURCE_DIR})

SET (OPENMEEG_LIBRARIES OpenMEEG OpenMEEGMaths)

# This section uses the OPENMEEG_INCLUDE_DIRECTORIES variable.
# Copy the UseOpenMEEG.cmake file to the binary tree for backward compatability.
CONFIGURE_FILE(
    ${OpenMEEG_SOURCE_DIR}/macros/UseOpenMEEG.cmake.in
    ${OpenMEEG_BINARY_DIR}/UseOpenMEEG.cmake COPYONLY IMMEDIATE)

# The "use" file.
SET(OPENMEEG_USE_FILE ${OpenMEEG_BINARY_DIR}/UseOpenMEEG.cmake)

# Configure OpenMEEGConfig.cmake for the build tree.
CONFIGURE_FILE(
    ${OpenMEEG_SOURCE_DIR}/macros/OpenMEEGConfig.cmake.in
    ${OpenMEEG_BINARY_DIR}/OpenMEEGConfig.cmake @ONLY IMMEDIATE)

# Generate another configure for installation

SET (OPENMEEG_LIBRARY_DIRECTORIES
    ${CMAKE_INSTALL_PREFIX}/lib
)

# The "use" file.
SET(OPENMEEG_USE_FILE ${CMAKE_INSTALL_PREFIX}/lib/UseOpenMEEG.cmake)

# Configure OpenMEEGConfig.cmake for the install tree.
CONFIGURE_FILE(
    ${OpenMEEG_SOURCE_DIR}/macros/OpenMEEGConfig.cmake.in
    ${OpenMEEG_BINARY_DIR}/macros/OpenMEEGConfig.cmake @ONLY IMMEDIATE)

INSTALL(FILES ${OpenMEEG_BINARY_DIR}/UseOpenMEEG.cmake
    DESTINATION lib)

INSTALL(FILES ${OpenMEEG_BINARY_DIR}/macros/OpenMEEGConfig.cmake
    DESTINATION lib)

=== Wrapping/CMakeLists.txt ===
IF(PYTHON_WRAP)
    FIND_PACKAGE(SWIG REQUIRED)
    INCLUDE(UseSwig_AlwaysShared.cmake)
    SUBDIRS(src)
ENDIF(PYTHON_WRAP)

=== documentation/CMakeLists.txt ===
IF ( BUILD_DOCUMENTATION )
    SUBDIRS(reference)
ENDIF ( BUILD_DOCUMENTATION )

IF ( BUILD_TUTORIALS )
    SUBDIRS(tutorial)
ENDIF ( BUILD_TUTORIALS )

=== libs/CMakeLists.txt ===
SUBDIRS(MatLib)

=== src/CMakeLists.txt ===
SET(OPENMEEG_HEADERS
    analytics.h assemble.h cpuChrono.h mesh3.h danielsson.h om_utils.h operators.h sensors.h MeshReader.h geometry.h triangle.h integrator.h vect3.h
    mesh3.h PropertiesSpecialized.h inversers.h
#   These files are imported from another repository.
#   Please do not update them in this repository.
    DataTag.H FileExceptions.H IOUtils.H MeshDescription/Reader.H MeshDescription/Normals.H MeshDescription/Domains.H MeshDescription/Exceptions.H
    Properties.H
)

ADD_LIBRARY(OpenMEEG ${LIB_TYPE}
    assembleFerguson.cpp assembleHeadMat.cpp assembleSourceMat.cpp assembleSensors.cpp
    danielsson.cpp geometry.cpp mesh3.cpp operators.cpp sensors.cpp inversers.cpp cpuChrono.cpp ${OPENMEEG_HEADERS}
)
TARGET_LINK_LIBRARIES(OpenMEEG OpenMEEGMaths "${OPENMEEG_OTHER_LIBRARIES}" ${LAPACK_LIBRARIES})

MACRO(OPENMEEG_EXECUTABLE EXECUTABLE)
    NEW_EXECUTABLE(${EXECUTABLE} ${ARGN} LIBRARIES OpenMEEG "${OPENMEEG_OTHER_LIBRARIES}")
ENDMACRO()

OPENMEEG_EXECUTABLE(om_presmooth presmooth.cpp ${OPENMEEG_HEADERS})
OPENMEEG_EXECUTABLE(om_minverser minverser.cpp ${OPENMEEG_HEADERS})
OPENMEEG_EXECUTABLE(om_inverse inverse.cpp ${OPENMEEG_HEADERS})
OPENMEEG_EXECUTABLE(om_gain gain.cpp ${OPENMEEG_HEADERS})
OPENMEEG_EXECUTABLE(om_forward forward.cpp ${OPENMEEG_HEADERS})
OPENMEEG_EXECUTABLE(om_assemble assemble.cpp)

# ================
# = INSTALLATION =
# ================

INSTALL(TARGETS OpenMEEG om_assemble om_forward om_gain om_inverse
    om_minverser om_presmooth
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib)

# ===========
# = TESTING =
# ===========

INCLUDE(TestHead.txt)
IF(BUILD_TESTING)
    TESTHEAD(1)
    TESTHEAD(2)

    OPTION(TEST_HEAD3 "Run tests on Head 3" OFF)

    IF (TEST_HEAD3)
        TESTHEAD(3)
    ENDIF()
ENDIF()

=== tests/CMakeLists.txt ===
INCLUDE(ComparisonTest)

SET_FILE_PROPERTIES(Suffix
    "HeadMat .hm" "HeadMatInv .hm_inv" "SurfSourceMat .ssm" "v2eeg .h2em" "SurfGainEEG .sgem"
    "EEGEST .est_eeg" "EEG-HEAT -eeg-heat.est_src" "EEG-MN -eeg-mn.est_src" "EEG-TV -eeg-tv.est_src"
    "Head2MEGMat .h2mm" "SurfSource2MEGMat .ss2mm" "SurfGainMEG .sgmm" "MEGEST .est_meg"
    "MEG-HEAT -meg-heat.est_src" "MEG-MN -meg-mn.est_src" "MEG-TV -meg-tv.est_src"
)

SET_FILE_PROPERTIES(CompareOptions
    "HeadMat -sym" "HeadMatInv -sym" "SurfSourceMat -full:-if1:binary:-if2:binary" "v2eeg -if:binary:-sparse"
    "SurfGainEEG -full" "EEGEST -full" "EEG-HEAT -full:-eps:0.02" "EEG-MN -full" "EEG-TV -full:-eps:0.0001"
    "Head2MEGMat -full" "SurfSource2MEGMat -full" "SurfGainMEG -full" "MEGEST -full"
    "MEG-HEAT -full:-eps:0.02" "MEG-MN -full" "MEG-TV -full"
)

############ IO TEST ##############
OPENMEEG_UNIT_TEST(load_geo
    SOURCES load_geo.cpp
    LIBRARIES OpenMEEG OpenMEEGMaths "${OPENMEEG_OTHER_LIBRARIES}"
    PARAMETERS ${OpenMEEG_SOURCE_DIR}/data/Models/Head1/Head1.geom ${OpenMEEG_SOURCE_DIR}/data/Models/Head1/Head1.cond)

NEW_EXECUTABLE(test_sensors test_sensors.cpp
               LIBRARIES OpenMEEG "${OPENMEEG_OTHER_LIBRARIES}")
NEW_EXECUTABLE(compare_matrix compare_matrix.cpp
               LIBRARIES OpenMEEGMaths "${OPENMEEG_OTHER_LIBRARIES}" ${LAPACK_LIBRARIES})
NEW_EXECUTABLE(om_validationEIT validationEIT.cpp ${OPEMEEG_HEADERS}
               LIBRARIES OpenMEEG OpenMEEGMaths "${OPENMEEG_OTHER_LIBRARIES}" ${LAPACK_LIBRARIES})

############ TEST COMMON RESULTS ON HEAD1 (Regression test) ##############

SET(COMPARISONS HeadMat HeadMatInv SurfSourceMat v2eeg SurfGainEEG EEGEST EEG-HEAT EEG-MN EEG-TV
                Head2MEGMat SurfSource2MEGMat SurfGainMEG MEGEST MEG-HEAT MEG-MN MEG-TV
)

FOREACH (COMPARISON ${COMPARISONS})
    SET(BASE_FILE_NAME Head1${Suffix_${COMPARISON}})
    SET(TEST_NAME ${COMPARISON}-Head1)
    OPENMEEG_COMPARISON_TEST(${COMPARISON}-Head1 ${BASE_FILE_NAME} initialTest/${BASE_FILE_NAME} ${CompareOptions_${COMPARISON}})
ENDFOREACH()

############ TEST EEG RESULTS ON DIPOLES ##############

IF (TEST_HEAD3)
    SET(HEAD3 3)
ENDIF()

SET(EPSILON 0.15)
FOREACH(DIP 1 2 3 4 5)
    FOREACH(HEADNUM 1 2 ${HEAD3})
        FOREACH(COMP mag rdm)
            SET(HEAD "Head${HEADNUM}")
            SET(BASE_FILE_NAME "${HEAD}-dip.est_eeg")
            # Compare EEG result with analytical solution obtained with Matlab
            OPENMEEG_COMPARISON_TEST("EEGEST-dip-${HEAD}-dip${DIP}-${COMP}"
                                     ${BASE_FILE_NAME} analytic/eeg_head${HEADNUM}_analytic.txt -${COMP} -eps ${EPSILON} -col ${DIP} -full)
            SET_TESTS_PROPERTIES("cmp-EEGEST-dip-${HEAD}-dip${DIP}-${COMP}" PROPERTIES DEPENDS EEG-dipoles-${HEAD})
        ENDFOREACH()
    ENDFOREACH()
ENDFOREACH()
# set tests that are expected to fail :
SET_TESTS_PROPERTIES(cmp-EEGEST-dip-Head1-dip1-mag PROPERTIES WILL_FAIL TRUE)
SET_TESTS_PROPERTIES(cmp-EEGEST-dip-Head1-dip4-rdm PROPERTIES WILL_FAIL TRUE)
SET_TESTS_PROPERTIES(cmp-EEGEST-dip-Head1-dip5-rdm PROPERTIES WILL_FAIL TRUE)

IF (WIN32)
    SET(VALIDATION_EIT "${EXECUTABLE_OUTPUT_PATH}/om_validationEIT")
ELSE()
    SET(VALIDATION_EIT "${CMAKE_CURRENT_BINARY_DIR}/om_validationEIT")
ENDIF()

FOREACH(HEADNUM 1 2 ${HEAD3})
    SET(HEAD "Head${HEADNUM}")
    SET(DATADIR ${OpenMEEG_SOURCE_DIR}/data)
    SET(MODELPREFIX ${DATADIR}/Models/${HEAD}/${HEAD})
    SET(TESTPREFIX ${OpenMEEG_BINARY_DIR}/tests/${HEAD})
    # validationEIT geometry.geom conductivity.cond dipoles.dip source.dsm headmatinv.bin out.eit_qgradVj out.eit_diffVf
    ADD_TEST(EITvalidation-dipoles-${HEAD}
        ${VALIDATION_EIT} ${MODELPREFIX}.geom ${MODELPREFIX}.cond
        ${DATADIR}/Computations/${HEAD}/${HEAD}.dip
        ${TESTPREFIX}.dsm ${TESTPREFIX}.hm_inv ${TESTPREFIX}.eit_qgradVj ${TESTPREFIX}.eit_diffVf)

    SET_TESTS_PROPERTIES(EITvalidation-dipoles-${HEAD} PROPERTIES DEPENDS HMINV-${HEAD})
    SET_PROPERTY(TEST EITvalidation-dipoles-${HEAD} APPEND PROPERTY DEPENDS DSM-${HEAD})

ENDFOREACH()

FOREACH(DIP 1 2 3 4 5)
    FOREACH(HEADNUM 1 2 ${HEAD3})
        SET(HEAD "Head${HEADNUM}")
        # Compare the potential results in a interior sphere of the Surf2Vol operator with analytical solution
        # obtained with Sphere (V.Hedou Modified)
        OPENMEEG_COMPARISON_TEST("EEGinternal-dip-${HEAD}-dip${DIP}"
                                 ${HEAD}-dip.est_eeginternal analytic/eeg_internal_analytic.txt -eps ${EPSILON} -col ${DIP} -full)

        SET_TESTS_PROPERTIES("cmp-EEGinternal-dip-${HEAD}-dip${DIP}" PROPERTIES DEPENDS InternalPot-dipoles-${HEAD})

        # Compare the q.gradVj to diffVf in order to validate the EIT problem
        OPENMEEG_COMPARISON_TEST("EIT-${HEAD}-dip${DIP}"
                                 ${HEAD}.eit_qgradVj ${OpenMEEG_BINARY_DIR}/tests/${HEAD}.eit_diffVf -eps ${EPSILON} -col ${DIP} -full)

        SET_TESTS_PROPERTIES("cmp-EIT-${HEAD}-dip${DIP}" PROPERTIES DEPENDS EITvalidation-dipoles-${HEAD})

    ENDFOREACH()
ENDFOREACH()
# set tests that are expected to fail :
SET_TESTS_PROPERTIES(cmp-EEGinternal-dip-Head1-dip5 PROPERTIES WILL_FAIL TRUE)

FOREACH(SENSORORIENT "" "-tangential" "-noradial")
    FOREACH(HEADNUM 1 2 ${HEAD3})
        SET(HEAD "Head${HEADNUM}")
        FOREACH(DIP 1 2 3 4 5)
            FOREACH(COMP mag rdm)
                # Compare MEG result with analytical solution obtained with Matlab
                OPENMEEG_COMPARISON_TEST("MEGEST-dip-${HEAD}-dip${DIP}${SENSORORIENT}-${COMP}"
                    ${HEAD}-dip${SENSORORIENT}.est_meg analytic/meg_analytic${SENSORORIENT}.txt -${COMP} -eps ${EPSILON} -col ${DIP} -full)

                SET_TESTS_PROPERTIES("cmp-MEGEST-dip-${HEAD}-dip${DIP}${SENSORORIENT}-${COMP}"
                    PROPERTIES DEPENDS MEG-dipoles-${HEAD}${SENSORORIENT})

            ENDFOREACH()
        ENDFOREACH()
        OPENMEEG_COMPARISON_TEST("MEGEST-dip${SENSORORIENT}-${HEAD}-dip6"
            ${HEAD}-dip${SENSORORIENT}.est_meg analytic/meg_analytic${SENSORORIENT}.txt -eps 0.001 -col 6 -full)

        SET_TESTS_PROPERTIES("cmp-MEGEST-dip${SENSORORIENT}-${HEAD}-dip6"
            PROPERTIES DEPENDS MEG-dipoles-${HEAD}${SENSORORIENT})

    ENDFOREACH()
ENDFOREACH()

# set tests that are expected to fail :
SET_TESTS_PROPERTIES(cmp-MEGEST-dip-Head1-dip2-tangential-mag PROPERTIES WILL_FAIL TRUE)
SET_TESTS_PROPERTIES(cmp-MEGEST-dip-Head1-dip2-tangential-rdm PROPERTIES WILL_FAIL TRUE)
SET_TESTS_PROPERTIES(cmp-MEGEST-dip-Head1-dip3-tangential-mag PROPERTIES WILL_FAIL TRUE)
SET_TESTS_PROPERTIES(cmp-MEGEST-dip-Head1-dip3-tangential-rdm PROPERTIES WILL_FAIL TRUE)
SET_TESTS_PROPERTIES(cmp-MEGEST-dip-Head1-dip4-tangential-mag PROPERTIES WILL_FAIL TRUE)
SET_TESTS_PROPERTIES(cmp-MEGEST-dip-Head1-dip4-tangential-rdm PROPERTIES WILL_FAIL TRUE)
SET_TESTS_PROPERTIES(cmp-MEGEST-dip-Head1-dip5-tangential-mag PROPERTIES WILL_FAIL TRUE)
SET_TESTS_PROPERTIES(cmp-MEGEST-dip-Head1-dip5-tangential-rdm PROPERTIES WILL_FAIL TRUE)
SET_TESTS_PROPERTIES(cmp-MEGEST-dip-Head2-dip4-tangential-mag PROPERTIES WILL_FAIL TRUE)
SET_TESTS_PROPERTIES(cmp-MEGEST-dip-Head2-dip4-tangential-rdm PROPERTIES WILL_FAIL TRUE)
SET_TESTS_PROPERTIES(cmp-MEGEST-dip-Head2-dip5-tangential-mag PROPERTIES WILL_FAIL TRUE)
SET_TESTS_PROPERTIES(cmp-MEGEST-dip-Head2-dip5-tangential-rdm PROPERTIES WILL_FAIL TRUE)
SET_TESTS_PROPERTIES(cmp-MEGEST-dip-Head1-dip4-noradial-mag PROPERTIES   WILL_FAIL TRUE)
SET_TESTS_PROPERTIES(cmp-MEGEST-dip-Head1-dip5-noradial-mag PROPERTIES   WILL_FAIL TRUE)

=== tools/CMakeLists.txt ===
ADD_EXECUTABLE(om_make_nerve make_nerve.cpp)
TARGET_LINK_LIBRARIES (om_make_nerve OpenMEEG "${OPENMEEG_OTHER_LIBRARIES}")

ADD_EXECUTABLE(om_mesh_convert mesh_convert.cpp)
TARGET_LINK_LIBRARIES (om_mesh_convert OpenMEEG "${OPENMEEG_OTHER_LIBRARIES}")

ADD_EXECUTABLE(om_mesh_info mesh_info.cpp)
TARGET_LINK_LIBRARIES (om_mesh_info OpenMEEG "${OPENMEEG_OTHER_LIBRARIES}")

ADD_EXECUTABLE(om_mesh_smooth mesh_smooth.cpp)
TARGET_LINK_LIBRARIES (om_mesh_smooth OpenMEEG "${OPENMEEG_OTHER_LIBRARIES}")

ADD_EXECUTABLE(om_mesh_concat mesh_concat.cpp)
TARGET_LINK_LIBRARIES (om_mesh_concat OpenMEEG "${OPENMEEG_OTHER_LIBRARIES}")

ADD_EXECUTABLE(om_register_squids register_squids.cpp)
TARGET_LINK_LIBRARIES (om_register_squids OpenMEEG "${OPENMEEG_OTHER_LIBRARIES}")

ADD_EXECUTABLE(om_squids2vtk squids2vtk.cpp)
TARGET_LINK_LIBRARIES (om_squids2vtk OpenMEEGMaths "${OPENMEEG_OTHER_LIBRARIES}")

ADD_EXECUTABLE(om_matrix_info matrix_info.cpp)
TARGET_LINK_LIBRARIES (om_matrix_info OpenMEEGMaths "${OPENMEEG_OTHER_LIBRARIES}")

ADD_EXECUTABLE(om_matrix_convert matrix_convert.cpp)
TARGET_LINK_LIBRARIES (om_matrix_convert OpenMEEGMaths "${OPENMEEG_OTHER_LIBRARIES}")

ADD_EXECUTABLE(om_vector_convert vector_convert.cpp)
TARGET_LINK_LIBRARIES (om_vector_convert OpenMEEGMaths "${OPENMEEG_OTHER_LIBRARIES}")

ADD_EXECUTABLE(om_symmatrix_convert symmatrix_convert.cpp)
TARGET_LINK_LIBRARIES (om_symmatrix_convert OpenMEEGMaths "${OPENMEEG_OTHER_LIBRARIES}")

ADD_EXECUTABLE(om_sparse_matrix_convert sparse_matrix_convert.cpp)
TARGET_LINK_LIBRARIES (om_sparse_matrix_convert OpenMEEGMaths "${OPENMEEG_OTHER_LIBRARIES}")

ADD_EXECUTABLE(om_check_geom check_geom.cpp)
TARGET_LINK_LIBRARIES (om_check_geom OpenMEEG "${OPENMEEG_OTHER_LIBRARIES}")

ADD_EXECUTABLE(om_mesh_to_dip mesh_to_dip.cpp)
TARGET_LINK_LIBRARIES (om_mesh_to_dip OpenMEEG "${OPENMEEG_OTHER_LIBRARIES}")

INSTALL(TARGETS om_make_nerve om_mesh_convert om_mesh_concat om_mesh_info om_mesh_smooth om_register_squids om_squids2vtk om_matrix_info om_matrix_convert om_symmatrix_convert om_sparse_matrix_convert om_vector_convert om_check_geom om_mesh_to_dip DESTINATION bin)

=== Wrapping/src/CMakeLists.txt ===
#######################################################################
# SWIG Embedding
#######################################################################

IF (PYTHON_WRAP)

    INCLUDE(FindPythonInterp)

    IF (PYTHON_EXECUTABLE)
        EXEC_PROGRAM("${PYTHON_EXECUTABLE}"
          ARGS "-c \"from distutils.sysconfig import get_python_lib; print get_python_lib(1)\""
          OUTPUT_VARIABLE PYTHON_SITE_ARCH
          RETURN_VALUE PYTHON_SITEARCH_NOT_FOUND)
        STRING(REGEX REPLACE "^.*/(lib|lib64)(/python.*)$" "\\1\\2" PYTHON_REL_SITE_ARCH ${PYTHON_SITE_ARCH})
    ENDIF()

    INCLUDE(FindNumpy.cmake)

    SET (MODULE_NAME openmeeg)
    SET (SWIG_SRC_FILE_NAME ${MODULE_NAME}.i)
    SET (CMAKE_SWIG_FLAGS  "-c++" )

    FIND_PACKAGE(SWIG REQUIRED)
    INCLUDE(${SWIG_USE_FILE})
    FIND_PACKAGE(PythonLibs)

    INCLUDE_DIRECTORIES(${PYTHON_INCLUDE_PATH} ${PYTHON_NUMPY_INCLUDE_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${OPENMEEG_INCLUDE_DIRECTORIES})

    SET(CMAKE_SWIG_FLAGS "")

    FILE(GLOB SWIG_SRC_FILE ${SWIG_SRC_FILE_NAME})

    SET_SOURCE_FILES_PROPERTIES(${SWIG_SRC_FILE_NAME} ${SWIG_SRC_FILE} PROPERTIES CPLUSPLUS ON)

    SET (SWIG_MODULE_${MODULE_NAME}_EXTRA_DEPS ${SWIG_SRC_FILE})
    IF (BUILD_DOCUMENTATION)
        SET(CMAKE_SWIG_FLAGS ${CMAKE_SWIG_FLAGS} -DDOCSTRINGS)
        ADD_CUSTOM_TARGET(docstrings
                          COMMAND python ${CMAKE_CURRENT_SOURCE_DIR}/doxy2swig.py ${PROJECT_BINARY_DIR}/documentation/reference/xml/index.xml docstrings.i)
        ADD_DEPENDENCIES(docstrings OpenMEEG-doxygen_outputs)
        ADD_DEPENDENCIES(OpenMEEG-documentation docstrings)
        SET (SWIG_MODULE_${MODULE_NAME}_EXTRA_DEPS ${SWIG_MODULE_${MODULE_NAME}_EXTRA_DEPS} ${PROJECT_BINARY_DIR}/Wrapping/src/docstrings.i)
    ENDIF (BUILD_DOCUMENTATION)

    SWIG_ADD_MODULE(${MODULE_NAME} python ${SWIG_SRC_FILE_NAME} "")

    IF (PYTHON_LIBRARIES)
        TARGET_LINK_LIBRARIES ("_${MODULE_NAME}" ${PYTHON_LIBRARIES} ${OPENMEEG_OTHER_LIBRARIES} OpenMEEG)
    ENDIF (PYTHON_LIBRARIES)

    INSTALL(TARGETS  "_${MODULE_NAME}"
            DESTINATION ${PYTHON_REL_SITE_ARCH}
            PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)

    INSTALL(FILES  ${OpenMEEG_BINARY_DIR}/Wrapping/src/${MODULE_NAME}.py
            DESTINATION ${PYTHON_REL_SITE_ARCH}
            PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ)

    # Test Python wrapping
    IF(BUILD_TESTING)
        ADD_TEST(openmeeg_python_aux
                 ${CMAKE_COMMAND} -E copy ${OpenMEEG_SOURCE_DIR}/data/demo.py ${OpenMEEG_BINARY_DIR}/Wrapping/src/)
        ADD_TEST(openmeeg_python
                 ${PYTHON_EXECUTABLE} ${OpenMEEG_BINARY_DIR}/Wrapping/src/demo.py --path ${OpenMEEG_SOURCE_DIR}/data)
    ENDIF()

ENDIF (PYTHON_WRAP)

=== documentation/reference/CMakeLists.txt ===
#
# Build the documentation
#

INCLUDE (Documentation OPTIONAL)

IF (BUILD_DOCUMENTATION)

    #
    # Configure the script and the doxyfile, then add target
    #
    IF(NOT DOT_PATH)
        GET_FILENAME_COMPONENT(DOT_PATH ${DOT} PATH)
    ENDIF(NOT DOT_PATH)

    CONFIGURE_FILE(
        ${OpenMEEG_SOURCE_DIR}/documentation/reference/doxyfile.in
        ${OpenMEEG_BINARY_DIR}/documentation/reference/doxyfile)

    #   The ALL in the next directive is necessary to cope with a CMake bug !!!
    #   Otherwise the target is never activated.

    ADD_CUSTOM_TARGET(OpenMEEG-documentation ALL)

    ADD_DEPENDENCIES(OpenMEEG-documentation OpenMEEG-doxygen_outputs)

    ADD_CUSTOM_TARGET(OpenMEEG-doxygen_outputs
                      COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/doxyfile
                      DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/doxyfile)

    INSTALL(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html/ DESTINATION share/doc/OpenMEEG/reference)

ENDIF (BUILD_DOCUMENTATION)

=== documentation/tutorial/CMakeLists.txt ===
INCLUDE(UseLATEX.cmake)

SUBDIRS(french english)

=== libs/MatLib/CMakeLists.txt ===
SUBDIRS(MatLib)

IF (BUILD_TESTING)
    SUBDIRS(Test)
ENDIF ()

=== macros/FortranCInterface/CMakeLists.txt ===
#=============================================================================
# Copyright 2009 Kitware, Inc.
#
# Distributed under the OSI-approved BSD License (the "License");
# see accompanying file Copyright.txt for details.
#
# This software is distributed WITHOUT ANY WARRANTY; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the License for more information.
#=============================================================================

cmake_minimum_required(VERSION 2.6.3)
project(FortranCInterface C Fortran)
include(${FortranCInterface_BINARY_DIR}/Input.cmake OPTIONAL)

# Check if the C compiler supports '$' in identifiers.
include(CheckCSourceCompiles)
check_c_source_compiles("
extern int dollar$(void);
int main() { return 0; }
" C_SUPPORTS_DOLLAR)

# List manglings of global symbol names to try.
set(global_symbols
  my_sub    # VisualAge
  my_sub_   # GNU, Intel, HP, SunPro, MIPSpro
  my_sub__  # GNU g77
  MY_SUB    # Intel on Windows
  mysub     # VisualAge
  mysub_    # GNU, Intel, HP, SunPro, MIPSpro
  MYSUB     # Intel on Windows
  ${FortranCInterface_GLOBAL_SYMBOLS}
  )
list(REMOVE_DUPLICATES global_symbols)

# List manglings of module symbol names to try.
set(module_symbols
  __my_module_MOD_my_sub  # GNU 4.3
  __my_module_NMOD_my_sub # VisualAge
  __my_module__my_sub     # GNU 4.2
  __mymodule_MOD_mysub    # GNU 4.3
  __mymodule_NMOD_mysub   # VisualAge
  __mymodule__mysub       # GNU 4.2
  my_module$my_sub        # HP
  my_module_mp_my_sub_    # Intel
  MY_MODULE_mp_MY_SUB     # Intel on Windows
  my_module_my_sub_       # PGI
  mymodule$mysub          # HP
  mymodule_mp_mysub_      # Intel
  MYMODULE_mp_MYSUB       # Intel on Windows
  mymodule_mysub_         # PGI
  ${FortranCInterface_MODULE_SYMBOLS}
  )
list(REMOVE_DUPLICATES module_symbols)

# Note that some compiler manglings cannot be invoked from C:
#   MIPSpro uses "MY_SUB.in.MY_MODULE"
#   SunPro uses "my_module.my_sub_"
#   PathScale uses "MY_SUB.in.MY_MODULE"

# Add module symbols only with Fortran90.
if(CMAKE_Fortran_COMPILER_SUPPORTS_F90)
  set(myfort_modules mymodule.f90 my_module.f90)
  set(call_mod call_mod.f90)
  set_property(SOURCE main.F PROPERTY COMPILE_DEFINITIONS CALL_MOD)
else()
  set(module_symbols)
endif()

# Generate C symbol sources.
foreach(symbol IN LISTS global_symbols module_symbols)
  # Skip symbols with '$' if C cannot handle them.
  if(C_SUPPORTS_DOLLAR OR NOT "${symbol}" MATCHES "\\$")
    if("${symbol}" MATCHES "SUB")
      set(upper "-UPPER")
    else()
      set(upper)
    endif()
    string(REPLACE "$" "S" name "${symbol}")
    set(source ${CMAKE_CURRENT_BINARY_DIR}/symbols/${name}${upper}.c)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/symbol.c.in ${source} @ONLY)
    list(APPEND symbol_sources ${source})
  endif()
endforeach()

# Provide symbols through Fortran.
add_library(myfort STATIC mysub.f my_sub.f ${myfort_modules})

# Provide symbols through C but fall back to Fortran.
add_library(symbols STATIC mymodule_.c my_module_.c ${symbol_sources})
target_link_libraries(symbols myfort)

# Require symbols through Fortran.
add_executable(FortranCInterface main.F call_sub.f ${call_mod})
target_link_libraries(FortranCInterface symbols)

=== debian/changelog ===
openmeeg (2.0.0.dfsg-5.1ubuntu1) saucy; urgency=low

  * Remove libtiff4-dev from Build-Depends to fix FTBFS.

 -- Logan Rosen <logan@ubuntu.com>  Wed, 24 Jul 2013 23:15:23 -0400

openmeeg (2.0.0.dfsg-5.1) unstable; urgency=low

  * Non-maintainer upload.
  * Adapt for API changes in MatIO 1.5
    + debian/patches/matio_1.5: new patch
    + debian/control: add versioned build dependency on libmatio-dev
    (Closes: #706804)
  * debian/patches/cmake_clean: new patch, fixes FTBFS with recent versions of
    cmake

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 19 Jun 2013 12:53:37 +0200

openmeeg (2.0.0.dfsg-5) unstable; urgency=low

  * debian/rules:
    - exclude 8 tests from being run on big-endian architectures due to
      incompatible architecture-specific test files (Closes: #631856)

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 25 Jun 2012 12:54:43 -0400

openmeeg (2.0.0.dfsg-4) unstable; urgency=low

  * debian/control:
    - tuned up descriptions per upstream request
    - boosted policy to 3.9.3
  * debian/copyright:
    - carries two recommended upstream references for citations
    - DEP5 compliant now
  * debian/rules:
    - added get-orig-source rules to compose upstream tarball from SVN
    - switched to debhelper7 from cdbs
    - generate debian/pyversions upon configure so package could build
      against any default python version (Closes: #646668)
    - call dh_numpy for numpy API version depends
  * debian/patches:
    - up_integrator_thiss to build with gcc 4.7x

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 20 Jun 2012 14:55:13 -0400

openmeeg (2.0.0.dfsg-3) unstable; urgency=low

  * Enabling unittesting during build:
    + override -DCMAKE_SKIP_RPATH:BOOL=OFF so RPATH should be used
      during compilation so that tests find dynamic libraries
  * Boost policy compliance to 3.9.2: BSD license verbatim
  * Adjusted copyright file for DEP5 (CeCILL-B indented, field names)
  * Build-Depend on python-dev instead of python-all-dev;
    feed cmake with a single (default) Python version (Closes: #626924)

 -- Yaroslav Halchenko <debian@onerussian.com>  Tue, 31 May 2011 15:52:58 -0400

openmeeg (2.0.0.dfsg-2) unstable; urgency=low

  * Initial Debian release (Closes: #517346)
  * Addressing ftp-master concerns:
    - debian/copyright: include complete text of CeCILL-B
      (see #565884 for why CeCILLs aren't yet in common-licenses)
    - debian/control: apparently CeCILL-B is now DFSG-compliant,
      so moving into main from non-free

 -- Yaroslav Halchenko <debian@onerussian.com>  Sun, 06 Jun 2010 21:57:36 -0400

openmeeg (2.0.0.dfsg-1) UNRELEASED; urgency=low

  * New upstream release
  * Moved to 3.0 (quilt) source format, absorbed into patch series:
    + installing headers under /usr/include/openmeeg
    + building of libOpenMEEG
  * Additional patch to do not rely on stripped contrib/ materials

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 02 Jun 2010 00:34:49 -0400

openmeeg (1.0.0-1) UNRELEASED; urgency=low

  * Initial packaging.
  * Override lintian warning about missing manpages.  Upstream doesn't provide
    them for numerous tools.
  * Override lintian warning about multiple libs in one package, since they
    are meant to be used together.

 -- Michael Hanke <michael.hanke@gmail.com>  Mon, 09 Nov 2009 12:19:00 -0500

=== debian/control ===
Source: openmeeg
Section: science
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: NeuroDebian Team <team@neuro.debian.net>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>, Michael Hanke <michael.hanke@gmail.com>
Build-Depends: debhelper (>= 7.0.50~), cmake, doxygen, python-numpy, swig, python-dev (>= 2.4), python-support (>= 0.6), libatlas-base-dev, libvtk5-dev, libtiff-dev, libmatio-dev (>= 1.5)
Standards-Version: 3.9.3
Homepage: http://www-sop.inria.fr/odyssee/software/OpenMEEG/
Vcs-Browser: http://git.debian.org/?p=pkg-exppsy/openmeeg.git
Vcs-Git: git://git.debian.org/git/pkg-exppsy/openmeeg.git

Package: libopenmeeg1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library for solving EEG and MEG forward and inverse problems
 OpenMEEG consists of state-of-the art solvers for forward problems in
 the field of MEG and EEG.  Solvers are based on the symmetric
 Boundary Element method [Kybic et al, 2005], providing excellent
 accuracy, particularly for superficial cortical sources. OpenMEEG can
 compute four types of lead fields (EEG, MEG, Internal Potential and
 Electrical Impedence Tomography).
 .
 This package provides dynamic libraries.

Package: libopenmeeg-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: openmeeg library -- development files
 OpenMEEG consists of state-of-the art solvers for forward problems in
 the field of MEG and EEG.  Solvers are based on the symmetric
 Boundary Element method [Kybic et al, 2005], providing excellent
 accuracy, particularly for superficial cortical sources. OpenMEEG can
 compute four types of lead fields (EEG, MEG, Internal Potential and
 Electrical Impedence Tomography).
 .
 This package provides static libraries and header files.


Package: openmeeg-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: openmeeg library -- command line tools
 OpenMEEG consists of state-of-the art solvers for forward problems in
 the field of MEG and EEG.  Solvers are based on the symmetric
 Boundary Element method [Kybic et al, 2005], providing excellent
 accuracy, particularly for superficial cortical sources. OpenMEEG can
 compute four types of lead fields (EEG, MEG, Internal Potential and
 Electrical Impedence Tomography).
 .
 This package provides command line interface to openmeeg functionality.


Package: python-openmeeg
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, python-numpy
Provides: ${python:Provides}
XB-Python-Version: ${python:Versions}
Description: openmeeg library -- Python bindings
 OpenMEEG consists of state-of-the art solvers for forward problems in
 the field of MEG and EEG.  Solvers are based on the symmetric
 Boundary Element method [Kybic et al, 2005], providing excellent
 accuracy, particularly for superficial cortical sources. OpenMEEG can
 compute four types of lead fields (EEG, MEG, Internal Potential and
 Electrical Impedence Tomography).
 .
 This package provides Python bindings for OpenMEEG library.

=== debian/rules ===
#!/usr/bin/make -f
srcpkg := $(shell LC_ALL=C dpkg-parsechangelog | grep '^Source:' | cut -d ' ' -f 2,2)
debver := $(shell LC_ALL=C dpkg-parsechangelog | grep '^Version:' | cut -d ' ' -f 2,2 )
uver := $(shell echo $(debver) | cut -d '-' -f 1,1 | sed -e 's,.dfsg,,g' )

PYVER   := $(shell pyversions -vd)

DH_VERBOSE = 1

TESTS_EXCLUDES := $(shell python -c 'import numpy as np; print np.little_endian' \
	| grep -q False \
	&& echo "-E 'cmp-(HeadMat(|Inv)|SurfSourceMat|v2eeg|SurfGainEEG|Head2MEGMat|SurfSource2MEGMat|SurfGainMEG)-Head1'")

# one ring to rule them all ...
%:
	dh $@


# The CMake flags for Debian (started from fslview's rules)
# - Search for VTK instead of a fixed path to be compatible with post-etch
#   versions and Ubuntu.
override_dh_auto_configure:
	dh_auto_configure -- \
			  -DCMAKE_EXE_LINKER_FLAGS:STRING="$(LDFLAGS)" \
              -DCMAKE_MODULE_LINKER_FLAGS:STRING="$(LDFLAGS)" \
              -DCMAKE_SHARED_LINKER_FLAGS:STRING="$(LDFLAGS)" \
              -DVTK_DIR:PATH=$$(dirname $$(find /usr/lib -name VTKConfig.cmake 2>/dev/null|head -n1)) \
              -DATLAS_INCLUDE_PATH:PATH=/usr/include/atlas \
              -DBUILD_SHARED:BOOL=ON \
              -DBUILD_TESTING:BOOL=ON \
              -DPYTHON_WRAP:BOOL=ON \
              -DPython_ADDITIONAL_VERSIONS:STRING=$(PYVER) \
              -DUSE_VTK:BOOL=OFF \
              -DCMAKE_SKIP_RPATH:BOOL=OFF
	@echo "Generating debian/pyversion to overcome absent 'current'"
	echo $(PYVER) >| debian/pyversions

override_dh_auto_test:
	dh_auto_test -- ARGS="$(TESTS_EXCLUDES)"

override_dh_install:
	: # I: Assure versioned dependency on NumPy
	if [ -x /usr/bin/dh_numpy ]; then dh_numpy;	fi
	dh_install

# little trick to make use of the distutils class without having
# a distutils package
#makebuilddir/python-openmeeg::
#	touch setup.py
#
#clean::
#	-rm setup.py

# Fetch upstream source straight from SVN since there is no source
# tarball any longer
get-orig-source:
	utarball=../$(srcpkg)-$(uver).tar.gz; \
	git archive --format=tar --prefix=$(srcpkg)-$(uver)/ svn/release-2.1 | \
		gzip -9 > $$utarball; \
	echo "I: run git-import-orig $$utarball"

override_dh_clean:
	dh_clean
	rm -f debian/pyversions

=== debian/watch ===
version=3
opts="dversionmangle=s/.dfsg$//" \
 http://githubredir.debian.net/github/openmeeg/openmeeg /release-(.*).tar.gz
